# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%global apiversion 1.0.1
%define repodir_api %{_javadir}/repository.jboss.com/stax-api/%{apiversion}-brew
%define repodir_ri %{_javadir}/repository.jboss.com/codehaus-stax/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%global namedversion %{version}

%define section free

Name:           codehaus-stax
Version:        1.2.0
Release:        10%{?dist}
Epoch:          0
Summary:        Streaming API for XML
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://stax.codehaus.org/
Source0:        http://dist.codehaus.org/stax/distributions/stax-src-1.2.0.zip
Source1:        codehaus-stax-component-info.xml
Source2:        codehaus-stax-api-component-info.xml
Source3:        http://repo1.maven.org/maven2/stax/stax-api/1.0.1/stax-api-1.0.1.pom
Source4:        http://repo1.maven.org/maven2/stax/stax/1.2.0/stax-1.2.0.pom
Patch0:         codehaus-stax-stax-pom.patch
Patch1:         codehaus-stax-build.patch
Requires:       %{name}-api = %{epoch}:%{version}-%{release}
Requires:       dtdparser
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  ant-trax
BuildRequires:  dtdparser
BuildRequires:  java-devel
BuildRequires:  jpackage-utils
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  maven2-plugin-deploy
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Streaming API for XML (StAX) is a groundbreaking 
new Java API for parsing and writing XML easily and 
efficiently. 

%package api
Summary:        The StAX API
Group:          Development/Libraries/Java
%if 0
From <http://stax.codehaus.org/Home>:
13-Mar-2006: Stax API 1.0.1 maintenance release: fixes one critical implementation problem in
XMLInputFactory implementation detection (jaxp.properties that existed but missed stax impl entry
threw NullPointerException). No changes to API or javadocs.
%endif
Provides:       stax_1_0_api
Provides:       stax_1_0_1_api
Provides:       stax_api = 1.0.1
Provides:       codehaus-stax11-api = 1.0.1
Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils

%description api
%{summary}.

%package demo
Summary:        Demo for %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:         Artifacts to be uploaded to a repository library
Group:           Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -c
%{__cp} -p %{SOURCE4} stax-%{namedversion}.pom
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%{__rm} -r src/com/wutka
%{__mkdir_p} lib

%build
export CLASSPATH=$(%{_bindir}/build-classpath dtdparser)
export OPT_JAR_LIST=`%{__cat} %{_sysconfdir}/ant.d/{junit,trax}`
%{ant} all javadoc test

export CLASSPATH=${CLASSPATH}:$(pwd)/build/stax-api-%{apiversion}.jar:$(pwd)/build/stax-%{version}-dev.jar
pushd src
%{javac} samples/*.java
popd

%install
%{__rm} -rf %{buildroot}

# jar
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p build/stax-api-%{apiversion}.jar %{buildroot}%{_javadir}/%{name}-api-%{version}.jar
%{__cp} -p build/stax-%{version}-dev.jar %{buildroot}%{_javadir}/%{name}-ri-%{version}.jar
%{__ln_s} %{name}-api-%{version}.jar %{buildroot}%{_javadir}/%{name}-api.jar
%{__ln_s} %{name}-ri-%{version}.jar %{buildroot}%{_javadir}/%{name}-ri.jar

/bin/touch %{buildroot}%{_javadir}/stax_api.jar
/bin/touch %{buildroot}%{_javadir}/stax_1_0_api.jar
/bin/touch %{buildroot}%{_javadir}/stax_1_0_1_api.jar

# demo
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}-%{version}
%{__cp} -pr src/samples/ %{buildroot}%{_datadir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_datadir}/%{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr build/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms

%{__cp} -p %{SOURCE3} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-api.pom
/bin/touch %{buildroot}%{_datadir}/maven2/poms/JPP-stax_api.pom
/bin/touch %{buildroot}%{_datadir}/maven2/poms/JPP-stax_1_0_api.pom
/bin/touch %{buildroot}%{_datadir}/maven2/poms/JPP-stax_1_0_1_api.pom
%add_to_maven_depmap stax stax-api %{apiversion} JPP stax_api
%add_to_maven_depmap stax stax-api %{apiversion} JPP stax_1_0_api
%add_to_maven_depmap stax stax-api %{apiversion} JPP stax_1_0_1_api

%{__cp} -p stax-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-ri.pom
%add_to_maven_depmap stax stax %{version} JPP %{name}-ri

%if %with repolib
# repolib
%{_bindir}/mvn-jpp deploy:deploy-file -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-api.pom \
                                      -Dfile=%{buildroot}%{_javadir}/%{name}-api-%{version}.jar \
                                      -DrepositoryId=oss-releases \
                                      -Durl=file:$(pwd)/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-ri.pom \
                                      -Dfile=%{buildroot}%{_javadir}/%{name}-ri-%{version}.jar \
                                      -DrepositoryId=oss-releases \
                                      -Durl=file:$(pwd)/maven2-brew
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

%if 0
%define repodir %{repodir_ri}
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
%{__sed} -i 's/@VERSION@/%{version}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH1} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-ri-%{version}.jar %{buildroot}%{repodirlib}/stax.jar
%endif

%define repodir %{repodir_api}
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodir}/component-info.xml
%{__sed} -i 's/@VERSION@/%{apiversion}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH1} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-api.pom %{buildroot}%{repodirlib}/stax-api.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-api-%{version}.jar %{buildroot}%{repodirlib}/stax-api.jar
%endif

%post api
%{_sbindir}/update-alternatives --install %{_javadir}/stax_api.jar stax_api %{_javadir}/%{name}-api.jar 10001
%{_sbindir}/update-alternatives --install %{_javadir}/stax_1_0_api.jar stax_1_0_api %{_javadir}/%{name}-api.jar 10001
%{_sbindir}/update-alternatives --install %{_javadir}/stax_1_0_1_api.jar stax_1_0_1_api %{_javadir}/%{name}-api.jar 10001
%{_sbindir}/update-alternatives --install %{_datadir}/maven2/poms/JPP-stax_api.pom stax_api_pom %{_datadir}/maven/poms/JPP-%{name}-api.pom 10001
%{_sbindir}/update-alternatives --install %{_datadir}/maven2/poms/JPP-stax_1_0_api.pom stax_1_0_api_pom %{_datadir}/maven2/poms/JPP-%{name}-api.pom 10001
%{_sbindir}/update-alternatives --install %{_datadir}/maven2/poms/JPP-stax_1_0_1_api.pom stax_1_0_1_api_pom %{_datadir}/maven2/poms/JPP-%{name}-api.pom 10001
%update_maven_depmap

%preun api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove stax_api %{_javadir}/%{name}-api.jar
    %{_sbindir}/update-alternatives --remove stax_1_0_api %{_javadir}/%{name}-api.jar
    %{_sbindir}/update-alternatives --remove stax_1_0_1_api %{_javadir}/%{name}-api.jar
    %{_sbindir}/update-alternatives --remove stax_api_pom %{_datadir}/maven2/poms/JPP-%{name}-api.pom
    %{_sbindir}/update-alternatives --remove stax_1_0_api_pom %{_datadir}/maven2/poms/JPP-%{name}-api.pom
    %{_sbindir}/update-alternatives --remove stax_1_0_1_api_pom %{_datadir}/maven2/poms/JPP-%{name}-api.pom
fi

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-ri-%{version}.jar
%{_javadir}*/%{name}-ri.jar
%{_datadir}/maven2/poms/JPP-%{name}-ri.pom

%files api
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-api-%{version}.jar
%{_javadir}*/%{name}-api.jar
%ghost %{_javadir}*/stax_api.jar
%ghost %{_javadir}*/stax_1_0_api.jar
%ghost %{_javadir}*/stax_1_0_1_api.jar
%{_datadir}/maven2/poms/JPP-%{name}-api.pom
%ghost %{_datadir}/maven2/poms/JPP-stax_api.pom
%ghost %{_datadir}/maven2/poms/JPP-stax_1_0_api.pom
%ghost %{_datadir}/maven2/poms/JPP-stax_1_0_1_api.pom
%{_mavendepmapfragdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Apr 05 2011 Fernando Nasser <fnasser@redhat.com> 0:1.2.0-10
- Provide codehaus-stax11-api in the api subpackage

* Tue Feb 08 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.9
- add patches to repolib

* Tue Feb 08 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.8
- rebuild

* Tue Feb 08 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.7
- fix alternatives names

* Tue Feb 08 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.6
- use %%global for %%apiversion and %%namedversion macros

* Tue Feb 08 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.5
- rebuild

* Mon Feb 07 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.4
- patch pom for dtdparser
- BuildRequires: junit >= 0:3.8.1

* Mon Feb 07 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.3
- add stax:stax:1.2.0 pom

* Mon Feb 07 2011 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.2
- add virtuals for stax_api, stax_1_0_api, stax_1_0_1__api
- add virtuals for stax_api_pom, stax_1_0_api_pom, and stax_1_0_1_api_pom

* Fri Aug 14 2009 David Walluck <dwalluck@redhat.com> 0:1.2.0-0.1
- release
